<template>
  <div class="app-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container" style="margin: 10px 0 10px 0;">
      <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
        <el-form-item label="订单ID">
          <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.orderId" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="用户ID">
          <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.userId" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="妹子名称">
          <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.girlName" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="妹子ID">
          <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.girlUid" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="充值次数">
          <el-select v-model="queryParams.payCount1" placeholder="充值次数"  class="filter-item" style="width: 200px;">
            <el-option label="全部" value=""></el-option>
            <el-option label="<" value="lt"><</el-option>
            <el-option label="<=" value=le><=</el-option>
            <el-option label="=" value="eq">=</el-option>
            <el-option label=">" value="gt">></el-option>
            <el-option label=">=" value="ge">>=</el-option>
          </el-select>
          <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.payCount2" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="支付状态">
          <el-select v-model="queryParams.payStatus" placeholder="支付状态"  class="filter-item" style="width: 200px;">
            <el-option label="全选" value=""></el-option>
            <el-option label="待付款" value="0">待付款</el-option>
            <el-option label="已支付" value="1">已支付</el-option>
            <el-option label="已过期" value="2">已过期</el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="订单状态">
          <el-select v-model="queryParams.status" placeholder="订单状态"  class="filter-item" style="width: 200px;">
            <el-option label="全选" value=""></el-option>
            <el-option label="未完成" value="0">未完成</el-option>
            <el-option label="已完成" value="1">已完成</el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="创建时间">
          <el-date-picker
            v-model="queryParams.beginCreateTime"
            type="date"
            placeholder="开始日期"
            class="baseInput"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
            style="width: 200px;"
          >
          </el-date-picker>
          <span> - </span>
          <el-date-picker
            v-model="queryParams.endCreateTime"
            type="date"
            placeholder="结束日期"
            class="baseInput"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
            style="width: 200px;"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item label="更新时间">
          <el-date-picker
            v-model="queryParams.beginUpdateTime"
            type="date"
            placeholder="开始日期"
            class="baseInput"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
            style="width: 200px;"
          >
          </el-date-picker>
          <span> - </span>
          <el-date-picker
            v-model="queryParams.endUpdateTime"
            type="date"
            placeholder="结束日期"
            class="baseInput"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
            style="width: 200px;"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item label="金额">
          <el-select
            v-model="queryParams.amount"
            class="filter-item"
            placeholder="金额"
            style="width: 140px"
            filterable
            clearable
            remote
            reserve-keyword
          >
            <el-option
              v-for="item in amountData"
              :key="item.uid"
              :label="item.amount"
              :value="item.uid"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="会员等级">
          <el-select
            v-model="queryParams.vipLevel"
            class="filter-item"
            placeholder="会员等级"
            style="width: 140px"
            filterable
            clearable
            remote
            reserve-keyword
          >
            <el-option
              v-for="item in vipLevelData"
              :key="item.uid"
              :label="item.vipLevel"
              :value="item.uid"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="来源渠道">
          <el-select
            v-model="queryParams.source"
            class="filter-item"
            placeholder="来源渠道"
            style="width: 140px"
            filterable
            clearable
            remote
            reserve-keyword
          >
            <el-option
              v-for="item in sourceData"
              :key="item.source"
              :label="item.name"
              :value="item.source"
            ></el-option>
          </el-select>
        </el-form-item>

        <!--<el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind" v-permission="'/girlOrder/getList'">查询</el-button>-->
        <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">查询</el-button>
        <!--<el-button class="filter-item" type="primary" @click="handleAdd" icon="el-icon-export" v-permission="'/girlTag/export'">导出</el-button>-->
        <el-button class="filter-item" type="primary" icon="el-icon-s-flag" @click="exportData">导出</el-button>
        <el-button class="filter-item" type="primary" icon="el-icon-s-flag" @click="addUpData">自动统计当前</el-button>
      </el-form>
    </div>

    <el-table :data="tableData" style="width:100%"
              @selection-change="handleSelectionChange"
              @sort-change="changeSort"
              :default-sort="{prop: 'sort', order: 'descending'}"
              class="show_table" >
      <el-table-column label="订单ID" width="100" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.uid }}</span>
        </template>
      </el-table-column>
      <el-table-column label="流水号" width="200" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.orderId }}</span>
        </template>
      </el-table-column>
      <el-table-column label="金额" width="80" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.amount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="用户昵称" width="140" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.userNick }}</span>
        </template>
      </el-table-column>
      <el-table-column label="用户ID" width="80" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.userId }}</span>
        </template>
      </el-table-column>
      <el-table-column label="会员等级" width="80" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.vipLevel }}</span>
        </template>
      </el-table-column>
      <el-table-column label="会员类型" width="100" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.vipType }}</span>
        </template>
      </el-table-column>
      <el-table-column label="妹子名称" width="140" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.girlName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="妹子ID" width="80" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.girlUid }}</span>
        </template>
      </el-table-column>
      <el-table-column label="支付次数" width="80":show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.payCount == 1">首次</span>
          <span v-else-if="scope.row.payCount && scope.row.payCount !=0">续费{{scope.row.payCount}}</span>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" width="180" align="center" prop="createTime" sortable="custom" :sort-by="['createTime']">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="更新时间" width="180" align="center" prop="updateTime" sortable="custom" :sort-by="['updateTime']">
        <template slot-scope="scope">
          <span>{{ scope.row.updateTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="线下尾款" width="80" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.offPrice }}</span>
        </template>
      </el-table-column>
      <el-table-column label="妹子城市" width="80" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.cityName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="来源渠道" width="140" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.sourceName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="约会时间" width="180" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.serviceTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="约会地点" width="80" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.serviceType== 1">上门</span>
          <span v-if="scope.row.serviceType == 2">租屋</span>
          <span v-if="scope.row.serviceType == 3">酒店</span>
        </template>
      </el-table-column>
      <el-table-column label="支付时间" width="180" align="center" prop="payTime" sortable="custom" :sort-by="['updateTime']">
        <template slot-scope="scope">
          <span v-if="scope.row.payStatus == 1">{{ scope.row.payTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="支付状态" width="80" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.payStatus == 0">待付款</span>
          <span v-if="scope.row.tableData == 1">已支付</span>
          <span v-if="scope.row.payStatus == 2">已过期</span>
        </template>
      </el-table-column>
      <el-table-column label="订单状态" width="80" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.status == 0">未完成</span>
          <span v-if="scope.row.status == 1">已完成</span>
        </template>
      </el-table-column>

      <el-table-column label="操作" min-width="60" fixed="right" align="center">
        <template slot-scope="scope">
          <!--<el-button @click="handleEdit(scope.row)" type="primary" size="small" v-permission="'/girlOrder/edit'">编辑</el-button>-->
          <el-button @click="handleEdit(scope.row)" v-if="scope.row.status == 0" type="primary" size="small">编辑</el-button>
        </template>
      </el-table-column>

    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>

    <!-- 添加或修改对话框 -->
    <el-dialog :title="title" :visible.sync="dialogFormVisible" :before-close="handleClose" width="30%">
      <el-form :model="form" ref="form">
        <el-form-item label="订单ID:" v-if="form.uid" :label-width="formLabelWidth">
          <span>{{form.uid}}</span>
        </el-form-item>
        <el-form-item label="流水号:" :label-width="formLabelWidth">
          <span>{{form.orderId}}</span>
        </el-form-item>
        <el-form-item label="金额:" :label-width="formLabelWidth">
          <span>{{form.amount}}</span>
        </el-form-item>
        <el-form-item label="用户昵称:" :label-width="formLabelWidth">
          <span>{{form.userNick}}</span>
        </el-form-item>
        <el-form-item label="用户ID:" :label-width="formLabelWidth">
          <span>{{form.userId}}</span>
        </el-form-item>
        <el-form-item label="妹子名称:" :label-width="formLabelWidth">
          <span>{{form.girlName}}</span>
        </el-form-item>
        <el-form-item label="妹子ID:" :label-width="formLabelWidth">
          <el-input v-model="form.girlUid" auto-complete="off" style="width: 80%"></el-input>
        </el-form-item>
        <el-form-item label="支付状态:" :label-width="formLabelWidth">
          <span v-if="form.payStatus == 0">待付款</span>
          <span v-if="form.payStatus == 1">已支付</span>
          <span v-if="form.payStatus == 2">已过期</span>
        </el-form-item>
        <el-form-item label="收款码类型:" :label-width="formLabelWidth">
            <input type="radio" v-model="form.status" value="0">&nbsp; 未完成 &nbsp;
            <input type="radio" v-model="form.status" value="1">&nbsp; 已完成 &nbsp;
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="handleClose">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
    <el-dialog :title="countTitle" :visible.sync="dialogCountVisible" :before-close="handleCountClose" width="40%" >
      <table style="border:3px #cccccc solid;width: 100%;" cellpadding="10" border='1'>
        <thead>
        <tr>
          <th class="is-leaf"><div class="cell">查找订单数</div></th>
          <th class="is-leaf"><div class="cell">订单总金额</div></th>
        </tr>
        <tr>
          <td align="center"><div class="cell">{{count}}</div></td>
          <td align="center"><div class="cell">{{sum}}</div></td>
        </tr>
        </thead>
      </table>
      <div slot="footer" class="dialog-footer">
        <br><br><br>
      </div>

    </el-dialog>

  </div>
</template>

<script>
import {
  getOrderList,
  getAmountList,
  getVipLevelList,
  getSourceList,
  editOrder,
  sumAndCount,
} from "@/api/girlOrder";
import {
  export_json_to_excel
} from "@/vendor/Export2Excel";
export default {
  data() {
    return {
      countData: [], //支付次数
      queryParams:{//查询参数
        orderId: "",//订单ID
        userId: "", //用户ID
        girlName: "", //妹子名称
        girlUid: "", //妹子ID
        payCount: "", //支付次数
        beginCreateTime: "", //创建时间-开始
        endCreateTime: "", //创建时间-结束
        beginUpdateTime: "", //更新时间-开始
        endUpdateTime: "", //更新时间-开始
        payStatus: "", //支付状态
        status: "", //订单状态
        amount: "-1", //金额
        vipLevel: "-1", //会员等级
        source: "", //来源渠道

      },
      multipleSelection: [], //多选，用于批量删除
      tableData: [],
      amountData: [
        {
        amount:'全部',
        uid:'-1'}
        ],
      sourceData: [
        {
          name:'全部',
          source:''}
      ],
      vipLevelData: [
        {
          vipLevel:'全部',
          uid:'-1'}
      ],
      keyword: "",
      currentPage: 1,
      pageSize: 40,
      total: 0, //总数量
      title: "编辑",
      countTitle: "当前统计",
      sum: 0, //总金额
      count: 0, //总笔量
      dialogFormVisible: false, //控制弹出框
      dialogCountVisible: false, //控制弹出框
      formLabelWidth: "120px",
      isEditForm: false,
      orderByDescColumn: "", // 降序字段
      orderByAscColumn: "", // 升序字段
      form: {
        content: "",
        introduce: "",
        sort: 0,
      },
    };
  },
  created() {
    this.orderList();
    this.amountList();
    this.vipLevelList();
    this.sourceList();
    this.inCountData();
  },
  methods: {
    // 从后台获取数据,重新排序
    inCountData(){
      for (var i = 1; i < 101; i++){
        var count={};
        count.id=i;
        if (i ==1){
          count.name = "首次";
        }else {
          count.name = "续费" + i;
        }
        this.countData.push(count);
      }
    },
    changeSort (val) {
      // 根据当前排序重新获取后台数据,一般后台会需要一个排序的参数
      if(val.order == "ascending") {
        this.orderByAscColumn = val.prop
        this.orderByDescColumn = ""
      } else {
        this.orderByAscColumn = ""
        this.orderByDescColumn = val.prop
      }
      this.orderList()
    },
    orderList: function() {

      this.queryParams.currentPage = this.currentPage;
      this.queryParams.pageSize = this.pageSize;
      this.queryParams.orderByDescColumn = this.orderByDescColumn
      this.queryParams.orderByAscColumn = this.orderByAscColumn
      // console.log("订单查询参数="+JSON.stringify(this.queryParams))
      getOrderList(this.queryParams).then(response => {
        this.tableData = response.data.records;
        this.currentPage = response.data.current;
        this.pageSize = response.data.size;
        this.total = response.data.total;
      });
    },
    amountList: function() {
      var amountParams = {};
      amountParams.pageSize = 1000;
      amountParams.currentPage = 1;
      getAmountList(amountParams).then(response => {
        this.amountData.push(...response.data.records);
      });
    },
    vipLevelList: function() {
      var vipLevelParams = {};
      vipLevelParams.pageSize = 1000;
      vipLevelParams.currentPage = 1;
      getVipLevelList(vipLevelParams).then(response => {
        this.vipLevelData.push(...response.data.records);
      });
    },
    sourceList: function() {
      var sourceParams = {};
      sourceParams.pageSize = 1000;
      sourceParams.currentPage = 1;
      getSourceList(sourceParams).then(response => {
        this.sourceData.push(...response.data.records);
      });
    },
    getFormObject: function() {
      var formObject = {
        uid: null,
        content: null,
        clickCount: 0,
        sort: 0
      };
      return formObject;
    },
    handleFind: function() {
      this.currentPage = 1
      this.orderList();
    },

    handleEdit: function(row) {
      this.title = "编辑";
      this.dialogFormVisible = true;
      this.form = row;
    },
    /**
     * 翻页事件
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.orderList();
    },
    handleCurrentChange: function(val) {
      this.currentPage = val;
      this.orderList();
    },
    submitForm: function() {
      this.$refs.form.validate((valid) => {
        if(!valid) {
          console.log('校验失败')
          return;
        } else {
          editOrder(this.form).then(response => {
            if (response.code == this.$ECode.SUCCESS) {
              this.$commonUtil.message.success(response.message)
              this.dialogFormVisible = false;
              this.orderList();
            } else {
              this.$commonUtil.message.error(response.message)
            }
          });
        }
      })
    },
    // 改变多选
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleClose(){
      this.dialogFormVisible = false;
      this.orderList();
    },
    handleCountClose(){
      this.dialogCountVisible = false;
    },

    // 导出excel数据
    exportData() {
      // 表头对应关系
      const headers = {
        '订单ID': 'uid',
        '流水号': 'orderId',
        '金额': 'amount',
        '用户昵称': 'userNick',
        '用户ID': 'userId',
        '会员等级': 'vipLevel',
        '会员类型': 'vipType',
        '妹子名称': 'girlName',
        '妹子ID': 'girlUid',
        '支付次数': 'payCount',
        '创建时间': 'createTime',
        '更新时间': 'updateTime',
        '线下尾款': 'offPrice',
        '妹子城市': 'cityName',
        '来源渠道': 'sourceName',
        '约会时间': 'serviceTime',
        '约会地点': 'serviceType',
        '支付时间': 'payTime',
        '支付状态': 'payStatus',
        '订单状态': 'status',
      }

      this.queryParams.currentPage = 1;
      this.queryParams.pageSize = -1;
      this.queryParams.orderByDescColumn = this.orderByDescColumn
      this.queryParams.orderByAscColumn = this.orderByAscColumn
      getOrderList(this.queryParams).then(response => {
        const data = this.formatJson(headers, response.data.records)  // list是你的数据源，可以自己重新处理数据内容和类型
        export_json_to_excel(Object.keys(headers), data, '订单列表')
      });
    },
    addUpData() {
      this.queryParams.currentPage = 1;
      this.queryParams.pageSize = 10000;
      sumAndCount(this.queryParams).then(response => {
        this.sum = response.data.sum;
        this.count = response.data.count;
        this.dialogCountVisible=true;
      });
    },
    // 该方法负责将数组转化成二维数组
    formatJson(headers, rows) {
      // 首先遍历数组
      return rows.map(item => {
        return Object.keys(headers).map(key => {
          if (headers[key] === 'payCount') {
            if(item[headers[key]] ==1){
              return '首次';
            } else if(item[headers[key]] !=0 && item[headers[key]] != null) {
              return '续费' + item[headers[key]];
            }else {
              return '';
            }
          } else if (headers[key] === 'payStatus') {
            if(item[headers[key]] === 0){
              return '待付款';
            } else if(item[headers[key]] === 1) {
              return '已支付';
            } else if(item[headers[key]] === 2){
              return '已过期';
            }
          } else if (headers[key] === 'status') {
            if(item[headers[key]] === 0){
              return '未完成';
            } else if(item[headers[key]] === 1) {
              return '已完成';
            }
          } else if (headers[key] === 'serviceType') {
            if(item[headers[key]] === 1){
              return '上门';
            } else if(item[headers[key]] === 2) {
              return '租屋';
            } else if(item[headers[key]] === 3){
              return '酒店';
            }
          }



          return item[headers[key]]
        })
      })
    },

  }
};
</script>
<style scoped>
  .el-form-item {
    margin-bottom: 10px;
  }
</style>
